﻿using System;
using System.Windows.Forms;

namespace RichTextBoxZoom {
    internal class RichTextBoxEx : RichTextBox {

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
            switch (keyData) {
                case Keys.Control | Keys.Oemplus:
                    this.ZoomIn();
                    return true;

                case Keys.Control | Keys.OemMinus:
                    this.ZoomOut();
                    return true;

                case Keys.Control | Keys.D0:
                    this.ZoomReset();
                    return true;

                default: return base.ProcessCmdKey(ref msg, keyData);
            }
        }


        public void ZoomIn() {
            this.ZoomFactor = (float)Math.Round(Math.Min(5.0f, this.ZoomFactor + 0.1f), 1);
        }

        public void ZoomOut() {
            this.ZoomFactor = (float)Math.Round(Math.Max(0.1f, this.ZoomFactor - 0.1f), 1);
        }

        public void ZoomReset() {
            this.ZoomFactor = 2.0f; //bug workaround
            this.ZoomFactor = 1.0f;
        }

    }
}
